package org.eso.ohs.core.dbb.client;

import org.apache.log4j.Logger;
import org.eso.ohs.core.utilities.Convert;
/**
 *  A transducer to convert set/get of String values into set/get
 *  on an int property.  The target property's name is given to the
 *  constructor.
 *
 *  For example, users will call it's
 *  setValue/getValue methods.  Those calls will be translated into
 *  calls to setX/getX on the object given to the constructor.
 *
 * copied from RightAcesion.java 
 * @author cmavros 13/Sept/2001
 */

    /**
     * Converts data from the database from seconds 
     * to a string as follows hh:mm:ss
     */
    public class DbbExecutionTime extends Coordinate {

  
private static final String rcsid = "$Id: DbbExecutionTime.java,v 1.3 2005/04/11 13:53:44 tcanavan Exp $";

private static Logger stdlog_ = 
    Logger.getLogger( DbbExecutionTime.class );
 
    public String fromDatabaseData(Object obj) {
        int seconds = ((Integer)obj).intValue();
        String str = Convert.secToHHMMSS(seconds);
        return str;
      }


    /**
     * Converts data from a String to a meta-level equivalent of the
     * actual property's type, i.e. to a java.lang.Integer
     * representing an int.  Used with reflection to set
     * the new property value.
     *
     * @param value the new value of the property.
     */
      public Object toDatabaseData(String value) {
          int result = 0;
          result = Convert.HHMMSSToSec(value);
	  Integer objRes = new Integer(result);
	  if (stdlog_.isDebugEnabled())
	      stdlog_.debug(objRes); 
          return objRes;
      }
}
