package org.eso.ohs.core.gui.widgets;



import java.io.File;
import java.net.URL;

import javax.swing.ImageIcon;

import org.eso.ohs.core.gui.utilities.ImageUtils;

/* Utils.java is a 1.4 example used by FileChooserDemo2.java. */
public class Utils {
    public final static String jpeg = "jpeg";
    public final static String jpg = "jpg";
    public final static String gif = "gif";
    public final static String tiff = "tiff";
    public final static String tif = "tif";
    public final static String png = "png";

    /*
     * Get the extension of a file.
     */
    public static String getExtension(File f) {
        String ext = null;
        String s = f.getName();
        int i = s.lastIndexOf('.');

        if (i > 0 &&  i < s.length() - 1) {
            ext = s.substring(i+1).toLowerCase();
        }
        return ext;
    }

    /** Returns an ImageIcon, or null if the path was invalid. */
    protected static ImageIcon createImageIcon(String path) {
        ClassLoader loader = ImageUtils.class.getClassLoader();
        URL urlImage =  ClassLoader.getSystemResource(path);
        if (urlImage != null) {
            return new ImageIcon(urlImage);
        } else {
            System.err.println("Couldn't find file: " + path);
            return null;
        }
    }
}
