package org.eso.ohs.core.utilities;

import java.util.Enumeration;
import java.util.NoSuchElementException;

/**
 * A utility class used to implement an empty Enumeration.
 * 
 * <p>
 * $Id: EmptyEnumeration.java,v 1.1 2004/02/17 14:31:55 tcanavan Exp $
 * <br>
 * @author Bob Kemp
 */
public class EmptyEnumeration implements Enumeration {

    /**
     * Returns false because there are no elements to be enumerated.
     * 
     * @return false
     */
    public boolean hasMoreElements() {
	return false;
    }

    /**
     * Throws a NoSuchElementException exception because there are
     * no elements in the enumeration.
     * 
     * @return	    nothing -- just throws an exception
     * @exception   NoSuchElementException
     *				because there are no elements to return.
     */
    public Object nextElement() {
	throw new NoSuchElementException("DirectoryNode");
    }

}

