package org.eso.ohs.core.utilities;

import javax.swing.JOptionPane;

import org.apache.log4j.Category;
import org.jdom.input.JDOMParseException;

public class MsgManager {
	

    private static Category stdlog_ =
        Category.getInstance(MsgManager.class);
	/**
	 * @param text Text of the error message.
	 * @return A nicely formatted error message, including
	 *         input line number.
	 */
	public static String errmsg(String text, JDOMParseException e ) {
		StringBuffer sb = new StringBuffer();
		sb.append("line ");
		sb.append(e.getLineNumber());
		sb.append("; column " );
		sb.append(e.getColumnNumber());
		sb.append("; systemId ");
		sb.append(e.getSystemId());
		sb.append(";");
		sb.append( text );
		return sb.toString();
	}
	//per ora lo tengo solo per ragioni di compatibilita'
	public static String errmsg(String text) {
		StringBuffer sb = new StringBuffer();
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for assertion failure.
	 * @param text The error message
	 * @param e and IllegalArgumentExcetion.
	 * @return The text of the error message
	 * @deprecated It is meaningless raising and printing an IllegalArgumentException when an assertion fail.
	 * Use errPrecondition(), errInvariant(), errPostcondition().
	 */
	public static String errContract(String text, IllegalArgumentException e) {
		StringBuffer sb = new StringBuffer();
		sb.append("[Design by Contract Violation] " );
		sb.append(e.getLocalizedMessage());
		sb.append(";");
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for assertion failure.
	 * @param text The error message
	 * @param e and IllegalArgumentExcetion.
	 * @return The text of the error message
	 * @deprecated  Use errPrecondition(), errInvariant(), errPostcondition().
	 */
	public static String errContract(String text) {
		StringBuffer sb = new StringBuffer();
		sb.append("[Design by Contract Violation] " );
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for CISP failure
	 * @param text Error message
	 * @param e An IllegalArgumentException
	 * @return The text of the error message.
	 */
	public static String errCISP(String text, IllegalArgumentException e) {
		StringBuffer sb = new StringBuffer();
		sb.append("[CISP Violation] " );
		sb.append(e.getLocalizedMessage());
		sb.append(";");
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for CISP failure
	 * @param text Error message
	 * @return The text of the error message.
	 */
	public static String errCISP(String text) {
		StringBuffer sb = new StringBuffer();
		sb.append("[CISP Violation] " );
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for precondition assertion failure.
	 * @param text The error message
	 * @return The text of the error message
	 */
	public static String errPrecondition(String text) {
		StringBuffer sb = new StringBuffer();
		sb.append("[Design by Contract - Precondition Violation] " );
		sb.append( text );
		return sb.toString();
	}
	/**
	 * Standard message error for precondition assertion failure.
	 * @param text The error message
	 * @return The text of the error message
	 */
	public static String errInvariant(String text) {
		StringBuffer sb = new StringBuffer();
		sb.append("[Design by Contract - Invariant Violation] " );
		sb.append( text );
		return sb.toString();
	}
    /**
     * Standard message error for precondition assertion failure.
     * @param text The error message
     * @return The text of the error message
     */
    public static String errPostcondition(String text) {
        StringBuffer sb = new StringBuffer();
        sb.append("[Design by Contract - Postcondition Violation] " );
        sb.append( text );
        return sb.toString();
    }
    
    /**
     * Standard message error for precondition assertion failure.
     * @param text The error message
     * @return The text of the error message
     */
    public static void errDialog(Exception e) {
        errDialog(e.getMessage(),e);
    }
 
    /**
     * Standard message error for precondition assertion failure.
     * @param text The error message
     * @return The text of the error message
     */
    public static void errDialog(String msg, Exception e) {
        String message = "Error: " + msg;
        JOptionPane.showMessageDialog(
            null,
            message,
            "ERROR",
            JOptionPane.ERROR_MESSAGE);
        stdlog_.error(message,e);
    } 
    /**
     * Standard message error for precondition assertion failure.
     * @param text The error message
     * @return The text of the error message
     */
    public static void errDialog(String msg) {
        String message = "Error: " + msg;
        JOptionPane.showMessageDialog(
            null,
            message,
            "ERROR",
            JOptionPane.ERROR_MESSAGE);
        stdlog_.error(message);
    }
    
    
    
}