package org.eso.ohs.core.utilities;


/**
 * Utilitiy class for notifying listeners of a major change in
 * the program's state, eg loggin in as a different user or
 * system shutdown
 * 
 * <p>
 * $Id: SystemStatus.java,v 1.2 2004/02/17 14:40:05 tcanavan Exp $
 */

public class SystemStatus {

    /** Support for handling PropertyChangeEvent */
    private static EventListenerList listenerList_ = new EventListenerList();



    public static void addSystemStatusListener(SystemStatusListener lnr) {
	listenerList_.add(SystemStatusListener.class, lnr);
    }

    public static void removeSystemStatusListener(SystemStatusListener lnr) {
	listenerList_.remove(SystemStatusListener.class, lnr);
    }

    /**
     * Informs listeners of a change in the system status.
     * No details of which property of the old/new value are given.
     */
    public static void fireSystemStatusEvent(int evtType, Object src) {
	Object[] listeners = listenerList_.getListenerList();
	SystemStatusEvent statusEvent = new SystemStatusEvent(
					    evtType,
					    src == null ? new Object() : src
					);

	for (int i = listeners.length-2; i>=0; i-=2) {
	    if (listeners[i] == SystemStatusListener.class) {
		((SystemStatusListener)listeners[i+1]).systemStatusChange(
							    statusEvent
							);
	    }              
	}
    }

}



