/*
 * Created on Nov 9, 2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package org.eso.ohs.instruments;

import java.io.IOException;
import java.io.StringReader;
import java.util.List;

import org.apache.log4j.Logger;
import org.jdom.Document;
import org.jdom.Element;
import org.jdom.JDOMException;
import org.jdom.input.SAXBuilder;
import org.xml.sax.InputSource;

/**
 * Class ReadmeAttributesFactory
 * 
 * This class initialises the readme file attributes for a given instrument
 * which then can be assigned to the given business object. TODO Javadoc
 * 
 * @version $Revision: 1.22 $
 * @author tcanavan, Nov 9, 2004
 */

// $Id: ReadmeAttributesFactory.java,v 1.22 2005/02/10 09:40:36 tcanavan Exp $
public class ReadmeAttributesFactory {
    
    
    private static Logger stdlog_ = Logger.getLogger(ReadmeAttributesFactory.class);

    /**
     * 
     * @param type
     * @return Get the type that is stored in the database.
     */

    public static String getDbType(String type) {
        if (type.equals("FourStateBooleanType")) {
            return ReadmeMultiStateBooleanList.getDBType();
        }
        if (type.equals("ThreeStateBooleanType")) {
            return ReadmeMultiStateBooleanList.getDBType();
        }
        if (type.equals("emailAddressType")) {
            return ReadmeEmailaddressAttribute.getDBType();
        }
        if (type.equals("BooleanType")) {
            return ReadmeBooleanType.getDBType();
        }
        if (type.equals("largetext")) {
            return ReadmeTextAttribute.getDBType();
        }
        if (type.equals("integer")) {
            return ReadmeIntAttribute.getDBType();
        }
        if (type.equals("float")) {
            return ReadmeFloatAttribute.getDBType();
        }
        if (type.equals("normaltext")) {
            return ReadmeTextAttribute.getDBType();
        }
        if (type.equals("keywordlist")) {
            return ReadmeKeyword.getDBType();
        }
        if (type.equals("multilist")) {
            return ReadmeKeywordList.getDBType();
        }
        return "X";
    }

    /**
     * Create a readme attribute list which will store the readme data entered
     * by the user.
     * 
     * @param inst
     * @return A list of readme attributes.
     */

    public static ReadmeAttribute[] createReadmeAttributes(Instrument inst) {
        InstrumentConstraintConfig[] instConstraints = inst.getReadmeConfList();
        ReadmeAttribute[] readmeAttributes = new ReadmeAttribute[instConstraints.length];
        for (int i = 0; i < instConstraints.length; i++) {
            if (instConstraints[i].getSuperType().equals("ThreeStateBooleanType")) {
                readmeAttributes[i] = new ReadmeMultiStateBooleanList(
                        instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("emailAddressType")) {
                readmeAttributes[i] = new ReadmeEmailaddressAttribute(
                        instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("FourStateBooleanType")) {
                readmeAttributes[i] = new ReadmeMultiStateBooleanList(
                        instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("BooleanType")) {
                readmeAttributes[i] = new ReadmeBooleanType(instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("largetext")) {
                readmeAttributes[i] = new ReadmeTextAttribute(
                        instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("integer")) {
                readmeAttributes[i] = new ReadmeIntAttribute(instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("normaltext")) {
                readmeAttributes[i] = new ReadmeTextAttribute(
                        instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("keywordlist")) {
                readmeAttributes[i] = new ReadmeKeyword(instConstraints[i]);
                continue;
            }
            if (instConstraints[i].getSuperType().equals("multilist")) {
                readmeAttributes[i] = new ReadmeKeywordList(instConstraints[i]);
                continue;
            }
        }
        return readmeAttributes;
    }

    public static ReadmeAttribute [] creteReadmeAttribFromXMLString(Instrument inst,
            String xmlString) throws JDOMException, IOException {
        ReadmeAttribute[] readmeAttributes = createReadmeAttributes(inst);
        stdlog_.debug(xmlString);
        SAXBuilder builder = new SAXBuilder();
        StringReader rdr = new StringReader(xmlString.trim());
        Document doc;
        doc = builder.build(new InputSource(rdr));
        Element element = doc.getRootElement();
        List list = element.getChildren();
        for (int i = 0; i < readmeAttributes.length; i++) {
            for (int j = 0; j < list.size(); j++) {
                Element elm = (Element) list.get(j);
                String name = readmeAttributes[i].getName();                
                if (elm.getName().equals(name)) {
                    List dataList = elm.getChildren();
                    Element elmData = (Element)dataList.get(1);
                    readmeAttributes[i].setValue(elmData.getValue());
                }
            }
        }     
        return readmeAttributes;
    }
    
    public static ReadmeAttribute [] refreshReadmeAttribFromXMLString(ReadmeAttribute [] readmeAttributes,
            String xmlString) throws JDOMException, IOException {
        SAXBuilder builder = new SAXBuilder();
        StringReader rdr = new StringReader(xmlString.trim());
        Document doc;
        doc = builder.build(new InputSource(rdr));
        Element element = doc.getRootElement();
        List list = element.getChildren();
        for (int i = 0; i < readmeAttributes.length; i++) {
            for (int j = 0; j < list.size(); j++) {
                Element elm = (Element) list.get(j);
                String name = readmeAttributes[i].getName();                
                if (elm.getName().equals(name)) {
                    List dataList = elm.getChildren();
                    Element elmData=(Element)dataList.get(1);
                    readmeAttributes[i].setValue(elmData.getValue());
                }
            }
        }     
        return readmeAttributes;
    }


    public static ReadmeAttribute[] refreshReadmeAttributes(Instrument inst,
            ReadmeAttribute[] oldReadmeAttributes) {
        ReadmeAttribute[] readmeAttributes = createReadmeAttributes(inst);
        for (int i = 0; i < readmeAttributes.length; i++) {
            for (int j = 0; j < oldReadmeAttributes.length; j++) {
                if (readmeAttributes[i].getName().equals(
                        oldReadmeAttributes[j].getName())) {
                    String value = oldReadmeAttributes[j].getValue();
                    readmeAttributes[i].setValue(value);
                }
            }
        }
        return readmeAttributes;
    }
    
    public static boolean isEqualsMeta(Instrument inst,
            ReadmeAttribute[] oldReadmeAttributes) {
        ReadmeAttribute[] readmeAttributes = createReadmeAttributes(inst);
        if(oldReadmeAttributes.length != readmeAttributes.length) 
             return false;
        for (int i = 0; i < readmeAttributes.length; i++) {
            boolean found = false;
            for (int j = 0; j < oldReadmeAttributes.length; j++) {
                if (readmeAttributes[i].equalsMeta(
                        oldReadmeAttributes[j])) {
                     found = true;        
                }
            }
            if(!found) {
                return false;
            }
        }
        return true;
    }

}
