package org.eso.ohs.phase2.apps.p2pp;

import java.awt.datatransfer.Clipboard;
import java.awt.datatransfer.ClipboardOwner;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;

public class BOSelection implements Transferable, ClipboardOwner {

    protected Object selection_;

    protected DataFlavor flavor_;

    public static final DataFlavor[] dataFlavors_ =
        {
            LocalClipboard.BO_FLAVOR,
            LocalClipboard.TEMPLATE_FLAVOR,
            LocalClipboard.OB_COMMENT_FLAVOR,
            LocalClipboard.OB_COMMENT_INST_FLAVOR,
            LocalClipboard.FCS_FLAVOR,
            LocalClipboard.TIS_FLAVOR,
            LocalClipboard.ST_TIS_FLAVOR };

    public BOSelection(Object selection, DataFlavor flavor) {
        selection_ = selection;
        flavor_ = flavor;
    }

    public DataFlavor[] getTransferDataFlavors() {
        return dataFlavors_;
    }

    public boolean isDataFlavorSupported(DataFlavor f) {
        return f.equals(flavor_);
    }

    public Object getTransferData(DataFlavor f)
        throws UnsupportedFlavorException {
        if (f.equals(flavor_)) {
            return selection_;
        } else
            throw new UnsupportedFlavorException(f);
    }

    public void lostOwnership(Clipboard c, Transferable t) {
        selection_ = null;
    }

    public DataFlavor getSelectedFlavor() {
        return flavor_;
    }
}
