package org.eso.ohs.phase2.apps.p2pp;

import org.eso.ohs.core.gui.widgets.TableSorter;
import org.eso.ohs.dfs.StorableObject;


/**
 * This class is the sorter class for the FolderGridView
 * It sets the model in the base class
 *
 * %Id%
 *
 * @author Tim Canavan
 */ 


public class FolderGridTableSorter extends TableSorter {

    /**
     * Create a FolderGridTableSorter object
     */

    public FolderGridTableSorter() {
    }

    /**
     * Create a FolderGridTableSorter object
     * @param folderModel FolderGridView.Summarymodel
     */

    public FolderGridTableSorter(FolderGridView.SummaryModel folderModel) {
        setModel(folderModel);
    }

    /**
     * Set the model
     * @param folderModel summaryModel
     */

    public void setModel(FolderGridView.SummaryModel folderModel) {
        super.setModel(folderModel);      
    }

    /**
     * Get the StorableObject at a particular row in the grid
     * @param row row in grid.
     */

    public StorableObject getObjectAt(int row) {
        FolderGridView.SummaryModel mod = (FolderGridView.SummaryModel)model;
        StorableObject summ = mod.getObjectAt(row);
        return summ;
    }

}


