package org.eso.ohs.phase2.apps.p2pp;

import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.datatransfer.DataFlavor;
import java.awt.datatransfer.Transferable;
import java.awt.datatransfer.UnsupportedFlavorException;
import java.awt.event.ActionEvent;
import java.awt.event.InputEvent;
import java.awt.event.ItemEvent;
import java.awt.event.ItemListener;
import java.awt.event.KeyEvent;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.beans.PropertyChangeEvent;
import java.beans.PropertyChangeListener;
import java.io.IOException;
import java.util.Vector;

import javax.swing.Action;
import javax.swing.Box;
import javax.swing.Icon;
import javax.swing.JCheckBoxMenuItem;
import javax.swing.JComboBox;
import javax.swing.JComponent;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.JTabbedPane;
import javax.swing.JToolBar;
import javax.swing.JTree;
import javax.swing.KeyStroke;
import javax.swing.SwingConstants;
import javax.swing.SwingUtilities;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;
import javax.swing.event.EventListenerList;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;

import org.apache.log4j.Logger;
import org.eso.ohs.core.dbb.client.DismissAction;
import org.eso.ohs.core.gui.baseaction.ActionSuperclass;
import org.eso.ohs.core.gui.utilities.ImageUtils;
import org.eso.ohs.core.gui.widgets.ErrorMessages;
import org.eso.ohs.core.gui.widgets.OutOfMemoryReport;
import org.eso.ohs.core.utilities.JobListener;
import org.eso.ohs.core.utilities.ObjectIOException;
import org.eso.ohs.core.utilities.Period;
import org.eso.ohs.core.utilities.SystemStatusEvent;
import org.eso.ohs.core.utilities.SystemStatusListener;
import org.eso.ohs.dfs.BusinessObject;
import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.dfs.ObservationDescription;
import org.eso.ohs.dfs.ObservingRun;
import org.eso.ohs.dfs.Readme;
import org.eso.ohs.dfs.Summary;
import org.eso.ohs.dfs.Target;
import org.eso.ohs.instruments.Instrument;
import org.eso.ohs.instruments.InstrumentList;
import org.eso.ohs.p2pp.Folder;
import org.eso.ohs.persistence.AppConfig;
import org.eso.ohs.persistence.AutoSaver;
import org.eso.ohs.persistence.Config;
import org.eso.ohs.persistence.DirectoryNode;
import org.eso.ohs.persistence.Media;
import org.eso.ohs.persistence.OHSApplication;
import org.eso.ohs.persistence.ObjectEvent;
import org.eso.ohs.persistence.ObjectListener;
import org.eso.ohs.persistence.ObjectNotFoundException;
import org.eso.ohs.persistence.ObjectSelectionEvent;
import org.eso.ohs.persistence.ObjectSelectionListener;
import org.eso.ohs.persistence.ObjectSelector;
import org.eso.ohs.phase2.actions.ExportBOAction;
import org.eso.ohs.phase2.actions.FindingChartViewer;
import org.eso.ohs.phase2.actions.ShowFindingChartsAction;
import org.eso.ohs.phase2.apps.p2pp.actions.AttachEphFile;
import org.eso.ohs.phase2.apps.p2pp.actions.AttachFindingChartsMultiOBSel;
import org.eso.ohs.phase2.apps.p2pp.actions.CheckInAction;
import org.eso.ohs.phase2.apps.p2pp.actions.CheckInReadmeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.CheckOutReadmeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ClearEphFiles;
import org.eso.ohs.phase2.apps.p2pp.actions.ClearFindingChartsMultiOBSel;
import org.eso.ohs.phase2.apps.p2pp.actions.CreateBOAction;
import org.eso.ohs.phase2.apps.p2pp.actions.CreateDirectoryAction;
import org.eso.ohs.phase2.apps.p2pp.actions.DeleteBOAction;
import org.eso.ohs.phase2.apps.p2pp.actions.DeleteDirectoryAction;
import org.eso.ohs.phase2.apps.p2pp.actions.DetatchFindingCharts;
import org.eso.ohs.phase2.apps.p2pp.actions.DuplicateBOAction;
import org.eso.ohs.phase2.apps.p2pp.actions.EngModeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ExportReadmeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ImportBOAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ImportReadmeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ImportTargetListAction;
import org.eso.ohs.phase2.apps.p2pp.actions.OpenFolderAction;
import org.eso.ohs.phase2.apps.p2pp.actions.P2PPStage2VerifyBOAction;
import org.eso.ohs.phase2.apps.p2pp.actions.Phase1TargetsViewerAction;
import org.eso.ohs.phase2.apps.p2pp.actions.QuitAction;
import org.eso.ohs.phase2.apps.p2pp.actions.RefreshTargetDataAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ReloginAction;
import org.eso.ohs.phase2.apps.p2pp.actions.RenameDirectoryAction;
import org.eso.ohs.phase2.apps.p2pp.actions.RestartWindows;
import org.eso.ohs.phase2.apps.p2pp.actions.SelectAllAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ShowDbaseAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ShowDetailsAction;
import org.eso.ohs.phase2.apps.p2pp.actions.SynchronizeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.USDsubmit;
import org.eso.ohs.phase2.apps.p2pp.actions.VerifyReadmeFileAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ViewEditReadmeAction;
import org.eso.ohs.phase2.apps.p2pp.actions.ViewEphFileAction;
import org.eso.ohs.phase2.apps.p2pp.views.CBView;
import org.eso.ohs.phase2.apps.p2pp.views.OBView;
import org.eso.ohs.phase2.apps.p2pp.views.ViewContainer;
import org.eso.ohs.phase2.common.SimpleJpegViewer;

/**
 * Application main window.
 * 
 * <p>
 * 
 * $Id: MainWindow.java,v 1.64 2005/11/17 15:54:42 tcanavan Exp $
 * 
 * <br>
 * 
 * @author Bob Kemp <br>
 *         ChangeLog: Tim Canavan <br>
 *         ChangeLog: cmavros 2002/02/11, 1510/OT Add OBD Format <br>
 *         ChangeLog: cmavros 2002/02/11, 1512/P2PP, Add File->Clone menu item
 *         <br>
 *         ChangeLog: cmavros 22Apr02 1195/P2PP Add a menu option for checking
 *         evms before checking into the AppServer
 */
public class MainWindow extends MenuGroups {

    /** Icon to signify that a business object is locked, ie readonly */
    public final static Icon readme_icon = ImageUtils.getIcon("readme.gif");

    public final static Icon readme_locked_icon = ImageUtils
            .getIcon("readmelocked.gif");

    private static Logger stdlog_ = Logger.getLogger(MainWindow.class);

    private static final int TIMER_DELAY = 100;

    public static final String ALL_PERIODS_TEXT = "All";

    public static final String CLONING_ON = "  [CLONING ON]";

    public static final int OLDESTSHOWNPERIOD = 59;

    /** vector of MainWindow instances that have not been disposed of. */
    private static Vector windowVec_ = new Vector();

    /** HierarchyView component nested within this window */
    private HierarchyView hView_;

    /** FolderGridView component nested within this window */
    private FolderGridView folderView_;

    /** Media containing the objects displayed in this window */
    private Media device_;

    private MoveBOMenuHandler objectMover_;

    private MoveDirectoryMenuHandler directoryMover_;

    /** "File" menu object */
    private JMenu fileMenu_;

    /** "Folder" menu object */
    private JMenu folderMenu_;

    private JMenu readmeMenu_;

    private Action readmeEditViewAction_;

    private Action readmeEditViewActionToolBar_;

    private Action verifyReadmeAction_;

    private Action checkInReadmeAction_;

    private Action checkOutReadmeAction_;

    private Action exportReadmeAction_;

    private Action importReadmeAction_;

    private static JMenuItem opTemplates_;

    private static JMenuItem acqTemplate_;

    private static JMenuItem target_;

    private static JMenuItem constraint_;

    private static JCheckBoxMenuItem cloneMenuItem_;

    private Phase1TargetsViewer phase1TargetsViewer_;

    private AutoSaverListener autoSaverListener_;
    
    private JMenuItem displayFindingCharts_;

    private JMenuItem clearFindingChartItem_;

    private JMenuItem attachFindingChartItem_;

    private JMenuItem detatchFindingChartItem_;
    
    private JMenuItem importTargetListMenuItem_;

    
    
    private JMenuItem importListMenuItem;

    /**
     * Combo box to allow the user to select a subset of the observing
     * programmes to be displayed
     */
    private JComboBox periodSelector_;

    /** Singleton controller for details view, ie ObjectView subclasses */
    public static final Views view_ = new Views();

    /** Singleton controller for phase 1 information */
    // public static final Phase1Information phase1 = new Phase1Information();
    private JMenuItem moveMenuItem_;

    private JMenuItem verifyMenuItem_;

    /*
     * Commented out as part of bugzilla item: 2100 - not removed in case it is
     * requested again later. private JMenuItem verifyMenuItemApp_;
     */

    private JMenuItem checkInMenuItem_;

    private JMenuItem deleteMenuItem_;

    private JMenuItem expMenuItem_;

    private Action showDetailsAction_;

    private Action refreshTargetDataAction_;

    private Action verifyOBAction_;

    /*
     * Commented out as part of bugzilla item: 2100 - not removed in case it is
     * requested again later. private Action verifyOBActionApp_;
     */

    private Action duplicateOBAction_;

    private JMenuItem newBOMenuItem_;

    private Action newBOActionToolBar_;

    private Action showDetailsActionToolBar_;

    private Action verifyOBActionToolBar_;

    private Action duplicateOBActionToolBar_;

    private Action attachFCActionToolBar_; 

    private Action usdActionToolBar_;

    private JMenuItem selectAllMenuItem_;

    private JMenuItem importMenuItem_;

    private JMenu fcMenu_;
    
    private JMenu ephMenu_;


    private int tabIndex_ = 0;


    public void setEnabled(boolean enabled) {
        checkInMenuItem_.setEnabled(enabled);
        deleteMenuItem_.setEnabled(enabled);
        objectMover_.setEnabled(enabled);
        expMenuItem_.setEnabled(enabled);
        showDetailsAction_.setEnabled(enabled);
        verifyOBAction_.setEnabled(enabled);
        duplicateOBAction_.setEnabled(enabled);
        displayFindingCharts_.setEnabled(enabled);
        clearFindingChartItem_.setEnabled(enabled);
        showDetailsActionToolBar_.setEnabled(enabled);
        verifyOBActionToolBar_.setEnabled(enabled);
        duplicateOBActionToolBar_.setEnabled(enabled);
        selectAllMenuItem_.setEnabled(enabled);
    }


    /** 
     * Set actions that are only availe to OB's not CB's
     * 
     * @param enabled
     */

    public void setOBEnabled(boolean enabled) {
        refreshTargetDataAction_.setEnabled(enabled);
        fcMenu_.setEnabled(enabled);
        attachFCActionToolBar_.setEnabled(enabled); 
        importTargetListMenuItem_.setEnabled(enabled);
        ephMenu_.setEnabled(enabled);
    }

    private void createFindingChartMenu(FolderGridView view, Media device) {
        final String menuName = "Finding Charts";
        attachFindingChartItem_ = addMenuItem(menuName,
                new AttachFindingChartsMultiOBSel(view, device));
        clearFindingChartItem_ = addMenuItem(menuName,
                new ClearFindingChartsMultiOBSel(view));

        addSeparator(menuName);

        detatchFindingChartItem_ = addMenuItem(menuName,
                new DetatchFindingCharts(view, this, device));

        displayFindingCharts_ = addMenuItem(menuName,
                new ShowFindingChartsAction(Media.LOCAL, view, this, true));
        fcMenu_ = getMenu(menuName);
    }

    private void createEphFileMenu(FolderGridView view) {
        final String menuName = "Ephemeris Files";
        JMenuItem item = addMenuItem(menuName, new AttachEphFile(view));
        item = addMenuItem(menuName, new ClearEphFiles(folderView_));
        item = addMenuItem(menuName, new ViewEphFileAction(folderView_,
                Media.LOCAL));
        ephMenu_ = getMenu(menuName);


    }

    public void createActions() {
        showDetailsAction_ = new ShowDetailsAction(device_, folderView_);
        refreshTargetDataAction_ = new RefreshTargetDataAction(device_,
                folderView_);
        verifyOBAction_ = new P2PPStage2VerifyBOAction(folderView_, false,
                "Verify");

        /*
         * Commented out as part of bugzilla item: 2100 - not removed in case it
         * is requested again later.
         * 
         * if (checkAppServer()) { verifyOBActionApp_ = new
         * CheckInAction(folderView_, "External Verification"); }
         */
        duplicateOBAction_ = new DuplicateBOAction(folderView_);

        showDetailsActionToolBar_ = new ShowDetailsAction(device_, folderView_);
        attachFCActionToolBar_ = new AttachFindingChartsMultiOBSel(folderView_, device_);
          verifyOBActionToolBar_ = new P2PPStage2VerifyBOAction(folderView_,
                false, "Verify");
        duplicateOBActionToolBar_ = new DuplicateBOAction(folderView_);
    }

    /**
     * Creates the contents of the File menu and adds it to the JMenuBar.
     * 
     * @exception ObjectIOException
     *                if there was an error reading/writing an object
     */
    public void createFileMenu() throws ObjectIOException {
        final String menuName = FILEMENU_NAME;
        JMenuItem mnItem;

        newBOMenuItem_ = addMenuItem(menuName, new CreateBOAction(device_,
                folderView_));
        newBOMenuItem_.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,
                InputEvent.CTRL_MASK, false));

        objectMover_ = new MoveBOMenuHandler(device_, folderView_, hView_,
                fileMenu_);

        addSubMenu(menuName, objectMover_.createFolderMenu());
        addSeparator(menuName);

        mnItem = addMenuItem(menuName, showDetailsAction_);

        mnItem = addMenuItem(menuName, refreshTargetDataAction_);
        mnItem.setEnabled(false);

        verifyMenuItem_ = addMenuItem(menuName, verifyOBAction_);

        /*
         * Commented out as part of bugzilla item: 2100 - not removed in case it
         * is requested again later.
         * 
         * if (checkAppServer()) { verifyMenuItemApp_ = addMenuItem(menuName,
         * verifyOBActionApp_); verifyMenuItemApp_.setEnabled(false); }
         */

        checkInMenuItem_ = addMenuItem(menuName, new CheckInAction(folderView_,
                "Check-in"));
        checkInMenuItem_.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_K,
                InputEvent.CTRL_MASK, false));
        deleteMenuItem_ = addMenuItem(menuName, new DeleteBOAction(device_,
                folderView_));

        addSeparator(menuName);

        mnItem = addMenuItem(menuName, new ReloginAction(folderView_));

        mnItem = addMenuItem(menuName, new ShowDbaseAction(this));

        mnItem = addMenuItem(menuName, new Phase1TargetsViewerAction(this));

        mnItem = addMenuItem(menuName, new ObsRunRefresherAction(hView_));
        
        importTargetListMenuItem_ = addMenuItem(menuName, new ImportTargetListAction(folderView_));

        addSeparator(menuName);

        importMenuItem_ = addMenuItem(menuName, new ImportBOAction(device_,
                folderView_));
        importMenuItem_.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M,
                InputEvent.CTRL_MASK, false));

        expMenuItem_ = addMenuItem(menuName, new ExportBOAction(device_,
                folderView_, "Export...", true));
        expMenuItem_.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E,
                InputEvent.CTRL_MASK, false));

        addSeparator(menuName);

        mnItem = addMenuItem(menuName, new EngModeAction(folderView_));
        mnItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_H,
                InputEvent.CTRL_MASK, false));

        if (!Config.getCfg().isInEngineeringMode()) {
            mnItem.setEnabled(false);
        }

        cloneMenuItem_ = new JCheckBoxMenuItem("Clone OBs to Database");
        getMenu(menuName).add(cloneMenuItem_);

        /** If in engineering mode enable the clone option and read defalut value */
        if (!Config.getCfg().isInEngineeringMode()) {
            cloneMenuItem_.setEnabled(false);
        } else {
            cloneMenuItem_
                    .setSelected(AppConfig.getAppConfig().isCloneModeId());
        }
        cloneMenuItem_.addChangeListener(new ChangeListener() {
            public void stateChanged(ChangeEvent evt) {
                cloneMenuItemStateChanged(evt);
            }
        });

        addSeparator(menuName);

        mnItem = addMenuItem(menuName, new DismissAction(this));
        mnItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_W,
                InputEvent.CTRL_MASK, false));

        addExit();
    }

    public void createEditMenu() {
        final String menuName = "Edit";
        JMenuItem mnItem;
        selectAllMenuItem_ = addMenuItem(menuName, new SelectAllAction(
                folderView_));
        selectAllMenuItem_.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_A,
                InputEvent.CTRL_MASK, false));

        mnItem = addMenuItem(menuName, duplicateOBAction_);
        mnItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_D,
                InputEvent.CTRL_MASK, false));

    }

    /**
     * Creates the contents of the Folder menu and adds it to the JMenuBar.
     * 
     * @exception ObjectIOException
     *                if there was an error reading/writing an object
     */
    public void createFolderMenu() throws ObjectIOException {
        final String menuName = FOLDERMENU_NAME;
        JMenuItem mnItem;
        directoryMover_ = new MoveDirectoryMenuHandler(this, device_, hView_,
                folderMenu_);

        mnItem = addMenuItem(menuName, new CreateDirectoryAction(this, device_,
                hView_));

        mnItem = addMenuItem(menuName, new OpenFolderAction(this, device_,
                hView_));
        mnItem.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O,
                InputEvent.CTRL_MASK, false));

        mnItem = addMenuItem(menuName, new RenameDirectoryAction(this, hView_));

        JMenuItem menuItem = addSubMenu(menuName, directoryMover_
                .createFolderMenu());
        menuItem.setEnabled(false);
        mnItem = addMenuItem(menuName, new DeleteDirectoryAction(this, device_,
                hView_));

    }

    /**
     * Creates the contents of the Readme menu and adds it to the JMenuBar.
     * 
     * @exception ObjectIOException
     *                if there was an error reading/writing an object
     */
    public void createReadmeMenu() throws ObjectIOException {
        final String menuName = "Readme";

        readmeEditViewAction_ = new ViewEditReadmeAction(hView_);
        verifyReadmeAction_ = new VerifyReadmeFileAction(hView_);
        checkInReadmeAction_ = new CheckInReadmeAction(hView_);
        checkOutReadmeAction_ = new CheckOutReadmeAction(hView_);
        exportReadmeAction_ = new ExportReadmeAction(hView_);
        importReadmeAction_ = new ImportReadmeAction(hView_);

        addMenuItem(menuName, readmeEditViewAction_);
        addMenuItem(menuName, verifyReadmeAction_);
        addSeparator(menuName);
        addMenuItem(menuName, checkInReadmeAction_);
        addMenuItem(menuName, checkOutReadmeAction_);
        addSeparator(menuName);
        addMenuItem(menuName, exportReadmeAction_);
        addMenuItem(menuName, importReadmeAction_);

    }

    /**
     * Create an icon with the given icon file and text
     * 
     * A M Chavan, 18-Jan-99, Creation
     */
    private JLabel makeStatusIcon(String iconFile, String iconText) {

        JLabel icon = new JLabel();

        icon.setHorizontalTextPosition(SwingConstants.CENTER);
        icon.setVerticalTextPosition(SwingConstants.BOTTOM);
        icon.setText(iconText);
        icon.setIcon(ImageUtils.getIcon(iconFile));

        return icon;
    }

    public void createSynchroniseMenu(ObjectSelector objSelector) {
        final String menuName = "Synchronise";
        addCopyBOMenu(menuName, objSelector);
        syncSelected_ = addMenuItem(menuName, new SynchronizeAction(
                folderView_, "Paste to Selected OBs", false));
        syncFolder_ = addMenuItem(menuName, new SynchronizeAction(folderView_,
                "Paste to Entire Folder", true));
        syncSelected_.setEnabled(false);
        syncFolder_.setEnabled(false);

        LocalClipboard.CLIPBOARD.addPropertyChangeListener(new SyncListener(
                syncSelected_));
        LocalClipboard.CLIPBOARD.addPropertyChangeListener(new SyncListener(
                syncFolder_));
        folderView_.addTabChangeListener(new TabChangeListener());
    }

    private void restartWindows() {
        if (phase1TargetsViewer_ != null) {
            phase1TargetsViewer_.setVisible(false);
            phase1TargetsViewer_.dispose();
        }
        phase1TargetsViewer_ = null;
    }

    /**
     * Returns the instance of the Phase 1 Target viewer class for this window.
     * 
     * @exception ObjectIOException
     *                if there was an error creating/initialising the window.
     */
    public Phase1TargetsViewer getPhase1TargetsViewer()
            throws ObjectIOException {
        if (phase1TargetsViewer_ == null) {
            synchronized (Phase1TargetsViewer.class) {
                if (phase1TargetsViewer_ == null) {
                    phase1TargetsViewer_ = new Phase1TargetsViewer(hView_);
                }
            }
        }
        return phase1TargetsViewer_;
    }

    /**
     * Constructor.
     * 
     * @param device
     *            media for objects displayed in this window.
     * 
     * @exception ObjectIOException
     *                if there was an error reading/writing an object
     * 
     * A M Chavan, 18-Jan-99: changed definition of status icons
     */
    public MainWindow(Media device) throws ObjectIOException {

        stdlog_.debug(" p2pp.MainWindow: Started constructing MainWindow");

        device_ = device;

        Persistence objMgr = Persistence.getInstance();

        JPanel content = (JPanel) getContentPane();
        content.setLayout(new BorderLayout());

        JMenuBar mb = new JMenuBar();
        fileMenu_ = new JMenu("File");
        folderMenu_ = new JMenu("Folder");

        setJMenuBar(mb);
        mb.add(fileMenu_);

        //hView_ = new HierarchyView(device, objMgr.getRoot(device));
        ReadmeEditView view = ReadmeEditView.getInstance();
        // hView_.addTreeSelectionListener(new HierTreeSelectionListener());

        DirectoryNode node = objMgr.getRoot(device).getDirectories()[0];
        Folder folder = FolderFactory.getFolder(device, node);
        folderView_ = new FolderGridView(device, folder);
        hView_ = new HierarchyView(device, objMgr.getRoot(device),folderView_);

        Action quit = new QuitAction(this);

        content.registerKeyboardAction(quit, KeyStroke.getKeyStroke(
                KeyEvent.VK_Q, KeyEvent.CTRL_MASK),
                JComponent.WHEN_IN_FOCUSED_WINDOW);
        folderView_.addObjectSelectionListener(view_);
        folderView_.addObjectSelectionListener(new SynchroMenuUpdater(
                folderView_));
        if (!Config.getCfg().isInOperationsMode()) {
            folderView_.addObjectSelectionListener(SimpleJpegViewer
                    .getInstance());
        } else {
            folderView_.addObjectSelectionListener(FindingChartViewer
                    .getInstance());
        }
        JSplitPane outerSplitPane = new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,
                labelledPane("Folders", hView_), labelledPane("Summaries",
                        folderView_));

        outerSplitPane.setOneTouchExpandable(true);
        content.add(outerSplitPane, BorderLayout.CENTER);

        createActions();
        createFileMenu();
        createFindingChartMenu(folderView_, Media.LOCAL);
        createEphFileMenu(folderView_);

        createReadmeMenu();
        createEditMenu();
        mb.add(folderMenu_);
        createFolderMenu();
        createReportsMenu(folderView_, device_);
        createSynchroniseMenu(folderView_);

        hView_.addSelectionListener(new TreeListener(hView_, folderView_));
        hView_.addSelectionListener(new DirectoryListener(hView_));

        AutoSaver saver = AutoSaver.getAutoSaver();
        if (autoSaverListener_ != null)
            saver.removeJobEvent(autoSaverListener_);
        autoSaverListener_ = new AutoSaverListener();
        saver.addJobEvent(autoSaverListener_);

        JToolBar toolbar = new JToolBar();
        /* cmavros 14-11-01 Make toolbar not floatable */
        toolbar.setFloatable(false);

        newBOActionToolBar_ = new CreateBOAction(device, folderView_);

        readmeEditViewActionToolBar_ = new ViewEditReadmeAction(hView_);
        usdActionToolBar_ = new USDsubmit(hView_);

        addToToolbar(newBOActionToolBar_, "create.gif", "New", toolbar);

        addToToolbar(duplicateOBActionToolBar_, "duplicate.gif", "Duplicate",
                toolbar);

        addToToolbar(verifyOBActionToolBar_, "verify.gif", "Verify", toolbar);

        addToToolbar(showDetailsActionToolBar_, "show.gif", "View", toolbar);
        
        addToToolbar(attachFCActionToolBar_, "attach.gif", "Attach FC", toolbar);

        toolbar.addSeparator(new Dimension(50, toolbar.getHeight()));

        addToToolbar(readmeEditViewActionToolBar_, "readme.gif", "Readme",
                toolbar);

        addToToolbar(usdActionToolBar_, "submit.gif", "p2pp-submit",
                "Signal ESO that the Phase 2 submission is complete", toolbar);

        // A M Chavan, 18-Jan-200 -- BEGIN

        // ****************************************
        // Status icons
        // ****************************************
        String iconFile;
        String iconText;

        // CCS connection
        // ----------------------------------------

        JLabel ccsIcon;

        if (AppConfig.getAppConfig().isCcsActive()) {
            iconFile = "ccsConn.gif";
            iconText = "CCS";
        } else {
            iconFile = "noCcsConn.gif";
            iconText = "No CCS";
        }
        ccsIcon = makeStatusIcon(iconFile, iconText);

        // Connection to database
        // ----------------------------------------

        JLabel dbIcon;

        if (AppConfig.getAppConfig().shouldUseAppServer()) {
            iconFile = "internet.gif";
            iconText = "AppServer";
        } else {
            iconFile = "direct.gif";
            iconText = "Direct";
        }
        dbIcon = makeStatusIcon(iconFile, iconText);

        JPanel infobar = new JPanel(new BorderLayout());
        JPanel p = new JPanel(new BorderLayout());

        p.add(toolbar, BorderLayout.NORTH);
        infobar.add(p, BorderLayout.WEST);

        // XXX The next 25-30 lines are the only way I could
        // get the period selector to a sensible position and
        // size that was also near to the HierarchyView.
        // XXX Feel free to improve it!
        Box rightBox = Box.createHorizontalBox();

        Box periodBox = Box.createVerticalBox();

        periodBox.add(Box.createVerticalGlue());
        periodBox.add(createPeriodSelector());
        periodBox.add(Box.createVerticalGlue());
        periodBox.add(new JLabel("Period"));
        periodBox.add(Box.createVerticalStrut(7));

        rightBox.add(Box.createHorizontalGlue());

        JPanel periodBoxPanel = new JPanel(new BorderLayout());

        periodBoxPanel.add(periodBox, BorderLayout.WEST);

        rightBox.add(Box.createHorizontalStrut(30));

        rightBox.add(periodBoxPanel);

        rightBox.add(Box.createHorizontalStrut(30));

        rightBox.add(ccsIcon);
        rightBox.add(Box.createHorizontalStrut(10));
        rightBox.add(dbIcon);
        rightBox.add(Box.createHorizontalStrut(20));

        infobar.add(rightBox, BorderLayout.CENTER);

        // A M Chavan, 18-Jan-200 -- END

        content.add(infobar, BorderLayout.NORTH);

        hView_.selectInitialFolder();

        content.validate();
        pack();
        setLocation(40, 40);
        addClosableWindow();

        windowVec_.addElement(this);
        setDefaultCloseOperation(JFrame.DO_NOTHING_ON_CLOSE);
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent ev) {
                MainWindow.this.dispose();
            }
        });

        P2PP.addSystemStatusListener(new SystemStatusListener() {
            public void systemStatusChange(SystemStatusEvent ev) {
                if (ev.getType() == SystemStatusEvent.RELOGIN) {
                    restartWindows();
                }
            }
        });
    }

    /**
     * Should be done using prooperty change event. But it is hard to find the
     * appropriate place.
     * 
     * @param enabled
     */

    public void setReadmeIcon(boolean enabled) {
        if (enabled) {
            readmeEditViewActionToolBar_.putValue("SmallIcon", readme_icon);
        } else {
            readmeEditViewActionToolBar_.putValue("SmallIcon",
                    readme_locked_icon);
        }
    }

    private boolean checkAppServer() {
        if (AppConfig.getAppConfig().shouldUseAppServer())
            return true;
        return false;
    }

    private JComboBox createPeriodSelector() {
        int currentPeriod = Period.getCurrentPeriod();
        /** cmavros Change list of periods to match browsers */
        String[] periods = new String[currentPeriod - OLDESTSHOWNPERIOD
                + (Period.ADDITIONAL + 1)];

        for (int j = 0; j < periods.length - 1; j++) {
            periods[j] = String.valueOf(Period.STARTPERIOD + j);
        }
        periods[periods.length - 1] = ALL_PERIODS_TEXT;

        periodSelector_ = new JComboBox(periods);
        periodSelector_.setBackground(getBackground());

        // Listener to sync HierarchyView with periodSelector_.
        periodSelector_.addItemListener(new PeriodListener(hView_));

        // Now we have a listener, set displayed period = ALL
        periodSelector_.setSelectedItem(periods[periods.length - 1]);

        return periodSelector_;
    }

    /**
     * Constructs a pane containing the component comp with a label above it.
     * 
     * @param name
     *            title for the given component.
     * @param comp
     *            component to be labelled.
     * 
     * @return labelled component
     */
    private JComponent labelledPane(String name, JComponent comp) {
        JPanel panel = new JPanel(new BorderLayout());
        JLabel lab = new JLabel(name);

        lab.setHorizontalAlignment(SwingConstants.CENTER);
        panel.add(lab, BorderLayout.NORTH);
        panel.add(comp, BorderLayout.CENTER);
        return panel;
    }

    /**
     * Constructs a pane containing the component comp with a label above it.
     * 
     * @param name
     *            title for the given component.
     * @param comp
     *            component to be labelled.
     */
    public void dispose() {
        // In operations mode, we DbaseWindow instead of MainWindow
        // Hence when we re-login as ops mode user, must not about quitting
        if (windowVec_.size() == 1 && !Config.getCfg().isInOperationsMode()) {
            P2PP.askAndQuit();
        } else {
            setVisible(false);
            super.dispose();
            windowVec_.removeElement(MainWindow.this);
        }
    }

    /**
     * Returns the FolderGridView component nested within this window.
     * 
     * @return table containing summaries of objects in this folder.
     */
    public FolderGridView getFolderView() {
        return folderView_;
    }

    /**
     * Returns the HierarchyView component nested within this window.
     * 
     * @return tree displaying the folder hierarchy on this device
     */
    public HierarchyView getHierarchyView() {
        return hView_;
    }

    /**
     * Returns the primary instance of MainWindow that still exists.
     * 
     * @return instance of MainWindow.
     */
    public static MainWindow getPrincipalWindow() {
        return windowVec_.size() == 0 ? null : (MainWindow) windowVec_
                .elementAt(0);
    }

    /**
     * Returns singleton instance of controller for details view, ie of
     * ObjectView subclasses.
     * 
     * @return ObjectView controller
     */
    public static Views getView() {
        return view_;
    }

    public Media getMedia() {
        return device_;
    }

    /**
     * Set the checkbox
     * 
     * @param en
     *            true if the checkbox is to be selected
     */
    public void setClone(boolean en) {
        cloneMenuItem_.setSelected(en);
    }

    /**
     * @return true if clone is selected
     */
    public static boolean isCloneSelected() {
        return cloneMenuItem_.isSelected();
    }

    /**
     * Changed when the state of the clone checkbox has changed
     * 
     * @param evt
     *            Event giving more information about changes
     */
    private void cloneMenuItemStateChanged(ChangeEvent evt) {
        JFrame frm = (JFrame) hView_.getTopLevelAncestor();
        String titleString = frm.getTitle();
        if (isCloneSelected()) {
            if (titleString.indexOf(CLONING_ON) == -1) {
                frm.setTitle(titleString + CLONING_ON);
            }
        } else {
            if (titleString.indexOf(CLONING_ON) != -1) {
                frm.setTitle(titleString.substring(0, titleString
                        .indexOf(CLONING_ON)));
            }
        }
    }

    /**
     * Adds the given action to the toolbar and sets it's icon and tooltip.
     * 
     * @param act
     *            action object to be added to toolbar
     * @param imgName
     *            name of the file containing the icon
     * @param toolTip
     *            tooltip text
     * @param toolbar
     *            toolbar to contain the action
     */

    /**
     * Listens to directory selection events, in order to update the Window
     * title bar.
     */
    private static class DirectoryListener implements TreeSelectionListener {

        /** HierarchyView component nested within this MainWindow instance */
        private HierarchyView hView_;

        /**
         * Constructor.
         * 
         * @param hv
         *            HierarchyView for this MainWindow
         */
        public DirectoryListener(HierarchyView hv) {
            hView_ = hv;
        }

        /**
         * Handler for changes in selected folder in HierarchyView.
         * 
         * @param ev
         *            event giving more information about changes A M Chavan,
         *            13-Jan-00: Added "P2PP" to title bar, minor changes to the
         *            code.
         */
        public void valueChanged(TreeSelectionEvent ev) {
            try {

                String titleString = OHSApplication.getShortDesc();

                JFrame frm = (JFrame) hView_.getTopLevelAncestor();
                Folder folder = hView_.getSelectedFolder();

                if (folder == null) {
                    frm.setTitle(titleString);
                    return;
                }

                DirectoryNode node = folder.getNode();
                DirectoryNode root = node;

                while (root.getParent().getParent() != null) {
                    root = root.getParent();
                }

                titleString += " " + node.getDescription();
                if (node != root)
                    titleString += "@" + root.getDescription();

                if (isCloneSelected()) {
                    frm.setTitle(titleString + CLONING_ON);
                } else {
                    frm.setTitle(titleString);
                }

            } catch (ObjectIOException e) {
                stdlog_.error(e);
            }
        }
    }

    /**
     * Listens to directory selection events, in order to update the object
     * displayed by FolderGridView.
     */
    private class TreeListener implements TreeSelectionListener {

        /** HierarchyView component nested within this MainWindow instance */
        private HierarchyView hView_;

        /** FolderGridView component nested within this MainWindow instance */
        private FolderGridView fView_;

        /**
         * Constructor.
         * 
         * @param hv
         *            nested HierarchyView
         * @param fv
         *            nested FolderGridView
         */
        public TreeListener(HierarchyView hv, FolderGridView fv) {
            hView_ = hv;
            fView_ = fv;
        }

        /**
         * Handler for changes in selected folder in HierarchyView.
         * 
         * @param ev
         *            event giving more information about changes
         */
        public void valueChanged(TreeSelectionEvent ev) {
            stdlog_.debug(" p2pp.MainWindow: Ev get Source " + ev.getSource());
            JTree tree = (JTree) ev.getSource();
            stdlog_.debug(" p2pp.MainWindow: Tree Model "
                    + tree.isSelectionEmpty());
            Folder folder = null;
            ObservingRun obsRun = null;
            if (tree.isSelectionEmpty()) {
                getMenu("Folder").setEnabled(false);
                newBOActionToolBar_.setEnabled(false);
                newBOMenuItem_.setEnabled(false);
                importMenuItem_.setEnabled(false);
                getMenu("Readme").setEnabled(false);
                readmeEditViewActionToolBar_.setEnabled(false);
                usdActionToolBar_.setEnabled(false);

            } else {
                try {
                    folder = hView_.getSelectedFolder();
                } catch (ObjectIOException e1) {
                    ErrorMessages.announceIOError(hView_, e1);
                }
                fView_.setFolder(folder);
                if (folder != null) {
                    obsRun = folder.findObsRun();
                    Instrument inst = InstrumentList.getInstance()
                            .getInstrument(obsRun.getInstCode(),
                                    obsRun.getIPVersion());
                    if (!obsRun.isServiceMode())
                        ephMenu_.setEnabled(false);
                    if (!obsRun.isServiceMode() || inst == null
                            || !inst.hasReadmeData()) {
                        getMenu("Readme").setEnabled(false);
                        readmeEditViewActionToolBar_.setEnabled(false);
                        usdActionToolBar_.setEnabled(false);
                    } else {
                        getMenu("Readme").setEnabled(true);
                        readmeEditViewActionToolBar_.setEnabled(true);
                        usdActionToolBar_.setEnabled(true);
                    }
                    Transferable t = LocalClipboard.CLIPBOARD.getContents(this);
                    if (t != null) {
                        DataFlavor flavor = ((BOSelection) t)
                                .getSelectedFlavor();
                        String name = flavor.getHumanPresentableName();
                        if (name.equals("InstrumentComments")) {
                            if (inst == null || !inst.hasInstComments()) {
                                syncSelected_.setEnabled(false);
                                syncFolder_.setEnabled(false);
                            } else {
                                syncSelected_.setEnabled(true);
                                syncFolder_.setEnabled(true);
                            }
                        }
                    }
                    getMenu("Folder").setEnabled(true);
                    newBOActionToolBar_.setEnabled(true);
                    newBOMenuItem_.setEnabled(true);
                    importMenuItem_.setEnabled(true);
                    if (!AppConfig.getAppConfig().isReadmeEnabled()) {
                        getMenu("Readme").setEnabled(false);
                        readmeEditViewActionToolBar_.setEnabled(false);
                        usdActionToolBar_.setEnabled(false);
                    }
                }                
            }

            try {
                if (!AppConfig.getAppConfig().isReadmeEnabled())
                    return;
                if (obsRun != null) {
                    Readme readme = obsRun.getReadme();
                    if (readme != null && readme.isCheckedIn()) {
                        // toolbar.
                        readmeEditViewActionToolBar_.putValue("SmallIcon",
                                readme_locked_icon);
                    } else {
                        readmeEditViewActionToolBar_.putValue("SmallIcon",
                                readme_icon);
                    }
                }
                if (!ReadmeEditView.getInstance().isVisible())
                    return;
                ReadmeEditView.getInstance().init(obsRun);
            } catch (ObjectIOException e) {
                ErrorMessages.announceIOError(folderView_.getTopLevelAncestor(),e);
            } catch (IOException e) {
                ErrorMessages.announceIOError(folderView_.getTopLevelAncestor(),e);
                
            } catch (ObjectNotFoundException e) {
                ErrorMessages.announceNoObject(folderView_.getTopLevelAncestor(),e);
            }
        }
    }

    /**
     * This class manages the various ViewContainer windows ("detail views") in
     * the system. It relays events on to the appropriate window to ensure that
     * the correct object is displayed in them at all times. It also provides a
     * central point for operations on the detail views.
     * 
     * <p>
     * This class also manages the use of single and multiple detail windows.
     * Normally, all object details are displayed in a single window (oneWin)
     * but, if the user so chooses, each object type can be displayed in a
     * separate window (obWin, odWin and tgWin).
     * 
     * <p>
     * For example, when an operation on multiple objects is started the visible
     * detail views are closed and later restored using methods in this class.
     */
    public static class Views implements ObjectSelectionListener {

        /** Show details panels in one auxiliary window or several? */
        private boolean showSingleWindow_ = true;

        /**
         * Are windows allowed to be made visible? This is disabled during
         * operations on larger numbers of objects, eg duplication.
         */
        private boolean displaySuppressed_;

        /**
         * Should the Target be displayed nested within the OBView? <br>
         * This property should be moved to a more sensible place -- but where?
         */
        private boolean showTargetNested_;

        /** Type of object most recently selected by the user */
        private Class last_selected_objType_ = Target.class;

        /** Details window for displaying all object types in one window */
        private ViewContainer oneWin = new ViewContainer();

        /* ObjectView for displaying ObsBlocks */
        private OBView obView_;

        private final ChangeEvent changeEvent_ = new ChangeEvent(this);

        /** Support for handling ChangeEvent */
        private transient EventListenerList listenerList_;

        /**
         * Structure for remembering which windows were open before a multiple
         * object operation.
         */
        private static class Memento {
            public boolean wasVisible_;
        }

        /**
         * Default constructor.
         */
        public Views() {
            stdlog_.debug(" p2pp.MainWindow: We are in Views");
            oneWin.setDefaultCloseOperation(JFrame.HIDE_ON_CLOSE);
            oneWin
                    .addObjectView(obView_ = new OBView(),
                            ObservationBlock.class);

            oneWin.addObjectView(new CBView(), CalibrationBlock.class);

            listenerList_ = new EventListenerList();
        }

        public OBView getObView() {
            return obView_;
        }

        public ViewContainer getOneWin() {
            return oneWin;
        }

        /**
         * Hides the detail views that are currently visible and returns a
         * Memento object that records which were open, for use by
         * restoreViews().
         * 
         * @return an instance of memento recording the windows that were
         *         visible.
         */
        public Object hideViews() {
            Memento mem = new Memento();
            mem.wasVisible_ = oneWin.isVisible();
            oneWin.setVisible(false);
            ReadmeEditView.getInstance().setVisible(false);
            return mem;
        }

        /**
         * Restores the detail views that are recorded in the Memento object
         * passed as an argument.
         * 
         * @param memObj
         *            Memento object returned from hideViews()
         * @exception IllegalArgumentException
         *                thrown if the parameter is not a Memento object
         */
        public void restoreViews(Object memObj) {
            if (!(memObj instanceof Memento)) {
                throw new IllegalArgumentException("restoreViews: bad value");
            }

            Memento mem = (Memento) memObj;
            oneWin.setVisible(mem.wasVisible_);
        }

        /**
         * Gets the value of the DisplaySuppressed property
         * 
         * @return current value of the DisplaySuppressed property
         */
        public boolean getDisplaySuppressed() {
            return displaySuppressed_;
        }

        /**
         * Sets the value of the DisplaySuppressed property
         * 
         * @param suppress
         *            new value of the DisplaySuppressed property
         */
        public void setDisplaySuppressed(boolean suppress) {
            displaySuppressed_ = suppress;
            fireChangeEvent();
        }

        /**
         * Tells the relevant detail view to display the specified business
         * object and may make that window visible. If display of windows is not
         * suppressed and forceVisible is true, then the detail view is made
         * visible. (If the window is already visible, that has the effect of
         * bringing it to the front)
         * 
         * @param device
         *            media for the business object
         * @param id
         *            id for the object to be displayed
         * @param objType
         *            type of the object to be displayed
         * @param forceVisible
         *            should the detail window be made visible
         */
        public void showObject(Media device, long id, Class objType,
                boolean forceVisible, boolean bringToTheFront)
                throws ObjectIOException, ObjectNotFoundException {

            last_selected_objType_ = objType;

            oneWin.display(device, id, objType, bringToTheFront);

            if (forceVisible && !displaySuppressed_) {

                // If the window is already visible but in a different
                // virtual screen, showObject() may appear to do nothing.
                // We make it invisible and then visible in the hope
                // that it will pop up on our current virtual screen.
                // It, at least, works with fvwm2.

                oneWin.setVisible(false);
                oneWin.setVisible(true);
            }
        }

        /**
         * Handler method for object selections. Calls showObject to display the
         * correct business object in a details view.
         * 
         * @param ev
         *            event giving more info about selected object
         */
        public void objectSelected(ObjectSelectionEvent ev) {

            Persistence objMgr = Persistence.getInstance();

            try {
                showObject(ev.getMedia(), ev.getObjectId(),
                        ev.getObjectClass(), ev.shouldMakeVisible(), ev
                                .shouldBringToTheFront());
            } catch (ObjectNotFoundException exc) {
                ErrorMessages.announceNoObject(null, exc);
                return; // Failure: return to caller
            } catch (ObjectIOException exc) {
                ErrorMessages.announceIOError(null, exc);
                return; // Failure: return to caller
            }
        }

        public void addChangeListener(ChangeListener lnr) {
            listenerList_.add(ChangeListener.class, lnr);
        }

        public void removeChangeListener(ChangeListener lnr) {
            listenerList_.remove(ChangeListener.class, lnr);
        }

        /**
         * Informs listeners of a property change. No details of which property
         * of the old/new value are given.
         */
        protected void fireChangeEvent() {
            Object[] listeners = listenerList_.getListenerList();

            for (int i = listeners.length - 2; i >= 0; i -= 2) {
                if (listeners[i] == ChangeListener.class) {
                    ((ChangeListener) listeners[i + 1])
                            .stateChanged(changeEvent_);
                }
            }
        }

        /**
         * Listener to make certain that we don't keep displaying a BO that has
         * been deleted.
         */
        private class ObjListener implements ObjectListener {
            private JMenuItem menuItem_;

            ObjListener(JMenuItem menuItem) {
                menuItem_ = menuItem;
            }

            public void objectAdded(ObjectEvent ev) {
                // don't care -- ignore
            }

            public void objectMoved(ObjectEvent ev) {
                // don't care -- ignore
            }

            public void objectRemovedFromRegistry(ObjectEvent ev) {
                // don't care -- ignore
            }

            public void objectRemoved(ObjectEvent ev) {

                BusinessObject sobj = oneWin.getDisplayedObject();

                // Has the displayed object just been deleted?
                if (sobj != null && ev.getObjectId() == sobj.getId()) {
                    oneWin.setDisplayedObject(null);
                }
            }
        }
    }

    /**
     * Listener class to set the displayed period(s) in the HierarchyView.
     */
    private class PeriodListener implements ItemListener {
        /** HierarchyView in which to set the period */
        private HierarchyView hView_;

        /** constructor */
        public PeriodListener(HierarchyView hView) {
            hView_ = hView;
        }

        /**
         * Selection change event handler
         * 
         * @param ev
         *            Object containing more information about the event
         */
        public void itemStateChanged(ItemEvent ev) {
            if (ev.getStateChange() == ItemEvent.SELECTED) {
                String item = ev.getItem().toString();
                int period;

                if (item.equals(ALL_PERIODS_TEXT)) {
                    period = HierarchyView.ALL_PERIODS;
                } else {
                    period = new Integer(item).intValue();
                }

                try {
                    hView_.setDisplayedPeriod(period);
                    objectMover_.updateMenu();
                    directoryMover_.updateMenu();
                } catch (ObjectIOException e) {
                    stdlog_.error(e);
                    ErrorMessages.announceIOError(MainWindow.this, e);
                }

                if (phase1TargetsViewer_ != null) {
                    try {
                        phase1TargetsViewer_.updatePeriod(period);
                    } catch (ObjectIOException e) {
                        stdlog_.error(e);
                        ErrorMessages.announceIOError(MainWindow.this, e);
                    }
                }
            }
        }
    }

    /**
     * Action to refresh the load or refresh local copies of the ObservingRun
     * objects for this user.
     */
    public class ObsRunRefresherAction extends ActionSuperclass {
        private HierarchyView hView_;

        public ObsRunRefresherAction(HierarchyView hView) {
            super(MainWindow.this.folderView_,
                    "Download/Refresh Observing Runs");
            hView_ = hView;
        }

        public void actionPerformedImpl(ActionEvent ev) {
            int period = hView_.getDisplayedPeriod();
            try {

                Summary[] summ = Phase1Information.obsRunsForPeriod(period);

                Phase1Information.refreshObsRuns(summ,
                        new Phase1Information.MessageListener() {
                            public void infoMessage(String msg) {
                                stdlog_.info(msg);
                            }

                            public void errorMessage(String msg) {
                                JOptionPane
                                        .showMessageDialog(
                                                null,
                                                new Object[] {
                                                        "Error downloading Observing Runs",
                                                        "", msg,
                                                        "Please contact ESO User Support Group." },
                                                "Download Error",
                                                JOptionPane.ERROR_MESSAGE);
                            }
                        });

                SwingUtilities.invokeLater(new RestartWindows());
            } catch (ObjectNotFoundException e) {
                stdlog_.error(e);
                ErrorMessages.announceNoObject(MainWindow.this, e);
            } catch (org.eso.ohs.core.utilities.ObjectIOException e) {
                stdlog_.error(e);
                ErrorMessages.announceIOError(MainWindow.this, e);
            }
        }
    }

    /**
     * This class listens for selection change events on the FolderGridView and
     * starts/restarts a Timer() object when one is received. The Timer, in
     * turn, fires an ActionEvent that calls back this class on every tick of
     * the Timer. Whenever an ActionEvent is received, we check whether the
     * selection has changed (but without reading the selected object!). If it
     * has changed, then nothing needs to be done. If the selection has not
     * changed, then the details view (ViewContainer) and menus are updated.
     * 
     * <p>
     * The real benefit of this scheme come when the user is scrolling down
     * using the keyboard, because not every object will be displayed in the
     * ViewContainer only ones where the user pauses when scrolling. The
     * downside is that if the user just uses the mouse to select new objects, a
     * short extra delay has been introduced.
     * 
     * <p>
     * In an ideal world, we would lookahead at the incoming mouse/keyboard
     * events but the Java world is not yet ideal.
     */
    /*
     * public class ViewUpdater implements ActionListener,
     * ObjectSelectionListener {
     * 
     * private Media device_;
     * 
     * private FolderGridView folderView_;
     * 
     * private Timer timer_;
     * 
     * private SynchroMenuUpdater menuUpdater_;
     * 
     * private long lastId_ = -1;
     * 
     * 
     * public ViewUpdater(Media device, FolderGridView folderView) { device_ =
     * device; folderView_ = folderView;
     * 
     * menuUpdater_ = new SynchroMenuUpdater(folderView);
     * 
     * timer_ = new Timer(TIMER_DELAY, this); timer_.setCoalesce(true); }
     * 
     * public void objectSelected(ObjectSelectionEvent ev) { if (!
     * timer_.isRunning()) { timer_.start(); } }
     * 
     * public void actionPerformed(ActionEvent ev) { Class cls =
     * folderView_.getDisplayedObjectClass(); Long idLong =
     * folderView_.getSelected(cls);
     * 
     * try { if (idLong == null) { if (lastId_ ==
     * ObjectSelectionEvent.NO_OBJECT) { timer_.stop();
     * view_.showObject(device_, lastId_, cls, false, true); } lastId_ =
     * ObjectSelectionEvent.NO_OBJECT; return; }
     * 
     * if (idLong.longValue() != lastId_) { lastId_ = idLong.longValue();
     * return; }
     * 
     * lastId_ = idLong.longValue();
     * 
     * view_.showObject( device_, lastId_, cls, false, false ); timer_.stop();
     * 
     * menuUpdater_.objectSelectionUpdated(); } catch (ObjectNotFoundException
     * exc) { ErrorMessages.announceNoObject(null, exc); return; // Failure:
     * return to caller } catch (ObjectIOException exc) {
     * ErrorMessages.announceIOError(null, exc); return; // Failure: return to
     * caller } } }
     */

    public class SynchroMenuUpdater implements ObjectSelectionListener,
            PropertyChangeListener {

        private ObjectSelector objSelector_;

        private BusinessObject currentBO_;

        public SynchroMenuUpdater(ObjectSelector objSelector) {
            objSelector_ = objSelector;
        }

        public void propertyChange(PropertyChangeEvent ev) {
            setEnabledSynchroniseMenu(currentBO_);
        }

        public void objectSelected(ObjectSelectionEvent ev) {
            if (currentBO_ != null) {
                currentBO_.removePropertyChangeListener(this);
            }
            currentBO_ = objSelector_.getDisplayedObject();
            if (currentBO_ != null) {
                currentBO_.addPropertyChangeListener(this);
            }
            setEnabledSynchroniseMenu(currentBO_);
            // NK stdlog_.debug(" p2pp.MainWindow: OBject Parameters " +
            // ev.paramString());
            if (ev.getObjectId() == ObjectSelectionEvent.NO_OBJECT) {
                setEnabled(false);
                setOBEnabled(false);
                if (ev.getRowCount() <= 0) {
                    setEnabledReports(false);
                } else
                    setEnabledSelectedReports(false);

            } else {
                setEnabled(true);
                setEnabledReports(true);
                setEnabledSelectedReports(true);
                if (tabIndex_ == 0) {
                    setOBEnabled(true);
                } else {
                    setOBEnabled(false);
                }
                ObservingRun obsRun = ((CalibrationBlock) currentBO_)
                        .getObsRun();
                if (!obsRun.isServiceMode()) {
                    ephMenu_.setEnabled(false);
                } 
            }
        }
    }

    private class TabChangeListener implements ChangeListener {
        public void stateChanged(ChangeEvent ev) {
            Transferable t = LocalClipboard.CLIPBOARD.getContents(this);
            tabIndex_ = ((JTabbedPane) ev.getSource()).getSelectedIndex();
            if (tabIndex_ == 0) {
                setOBEnabled(true);
                getMenu("Ephemeris Files").setEnabled(true);

            } else {
                setOBEnabled(false);
                getMenu("Ephemeris Files").setEnabled(false);
            }

            Object obj = null;
            String name = null;
            if (t != null) {
                DataFlavor flavor = ((BOSelection) t).getSelectedFlavor();
                name = flavor.getHumanPresentableName();
                try {
                    obj = t.getTransferData(flavor);
                } catch (IOException e) {
                    ErrorMessages.announceIOError(null, e);
                } catch (UnsupportedFlavorException e) {
                    String[] messages = new String[1];
                    messages[0] = "Unable to synchronize menu itmes";
                    ErrorMessages.announceError(null, messages, e);
                }
            }
            if (obj == null) {
                syncSelected_.setEnabled(false);
                syncFolder_.setEnabled(false);
            } else {
                BusinessObject bo = folderView_.getDisplayedObject();

                if (bo instanceof ObservationBlock) {
                    if (obj instanceof BusinessObject) {
                        syncSelected_.setEnabled(true);
                        syncFolder_.setEnabled(true);
                    }
                } else {
                    if (obj instanceof ObservationDescription
                            || name.equals("UserComments")) {
                        syncSelected_.setEnabled(true);
                        syncFolder_.setEnabled(true);
                    } else {
                        syncSelected_.setEnabled(false);
                        syncFolder_.setEnabled(false);
                    }
                }
            }

        }
    }

    /**
     * Listener to enable/disable menu items according to whether the clipboard
     * is empty or not.
     */
    private class SyncListener implements PropertyChangeListener {
        private JMenuItem menuItem_;

        SyncListener(JMenuItem menuItem) {
            menuItem_ = menuItem;
        }

        public void propertyChange(PropertyChangeEvent ev) {
            Transferable t = LocalClipboard.CLIPBOARD.getContents(this);
            if (t == null) {
                menuItem_.setEnabled(false);
            } else {
                menuItem_.setEnabled(true);
            }
        }
    }

    private class AutoSaverListener implements JobListener {
        /**
         * @see org.eso.ohs.utilities.JobListener#onStarted()
         */
        public void onStarted() {
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onFinished()
         */
        public void onFinished() {
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onCanceled()
         */
        public void onCanceled() {
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onMessage(java.lang.String)
         */
        public void onMessage(String message) {
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onException(java.lang.Exception)
         */
        public void onException(Exception exception) {
            alertUser(exception);
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onProgress(int, int)
         */
        public void onProgress(int toProcess, int processed) {
        }

        /**
         * @see org.eso.ohs.utilities.JobListener#onOutOfMemory(java.lang.OutOfMemoryError)
         */
        public void onOutOfMemory(OutOfMemoryError error) {
            OutOfMemoryReport.showMessage();
        }
    }

    /**
     * Alert the user that an I/O exception has occurred.
     * 
     * @param exc
     *            The offending I/O exception
     */
    public void alertUser(Exception exc) {
        try {
            AlertUser au = new AlertUser(exc);
            SwingUtilities.invokeLater(au);

            while (au.finished == false) {

            	
                if (!AutoSaver.isActive())
                    return;

                stdlog_.debug("AlertUser: sleeping...");
                Thread.sleep(500);
            }

            // Give the user a chance to quit, etc
            Thread.sleep(5000);
        } catch (InterruptedException e) {
            stdlog_.warn("", e);
        }
    }

    /**
     * 
     * Alert user to the fact that an error has occurred
     * 
     * @author tcanavan
     * 
     */

    private class AlertUser implements Runnable {
        private Exception exc_;

        public boolean finished;

        public AlertUser(Exception e) {
            exc_ = e;
            finished = false;
        }

        public void run() {
            ErrorMessages.announceIOError(MainWindow.this, exc_);
            finished = true;
        }
    }

}
