package org.eso.ohs.phase2.apps.p2pp;

import java.awt.Component;

import org.eso.ohs.dfs.CalibrationBlock;
import org.eso.ohs.dfs.ObservationBlock;
import org.eso.ohs.phase2.icdVcs.IcdVcsCfg;

/**
 * Clearing house for low-level configuration information.
 * 
 * <p>
 * $Id: TestIcdVcsCfg.java,v 1.1 2005/04/25 16:44:06 tcanavan Exp $
 */
public class TestIcdVcsCfg  extends IcdVcsCfg {

    ObservationBlock ob_;

    /** Default constructor */
    protected TestIcdVcsCfg(ObservationBlock ob) {
	ob_ = ob;
    }





    /**
     * The id of a set of selected object of the given type.
     * @param num the number of selected objects to return
     * 
     * @return	a set of Id for the selected object, or null is returned
     *          if nothing is selected
     */
    public long[] getSelections(int maxNumOBs) {
	long t[] = { ob_.getId() };
	return t;
        // return new long [0];
    }

    /**
     * Type of object that is currently displayed.
     * 
     * @return	Type of object to send to BOB
     */
     public  Class getObjType(long id) {
         return CalibrationBlock.class;
     }

    /**
     * Returns the CCS server name by which this application is to be known.
     * 
     * @return	name of the CCS server
     */
    public String getCCSServer() {
	return "schedule";
    }

    /**
     * Is the user currently in Visitor mode?
     * 
     * @return	true if in visitor mode, false otherwise
     */
    public boolean isInVisitorMode() {
	return true;
    }

    /**
     * Is the user currently in Engineering mode?
     * 
     * @return	true if in Engineering mode, false otherwise
     */
    public boolean isInEngineeringMode() {
	return true;
    }

    /**
     * Is the user currently in Clone mode?
     * 
     * @return	true if in clone mode, false otherwise
     */
    public boolean isInCloneMode() {
	return true;
    }

    /**
     * Name of the current user.
     * Note: it's actually a numerical id.
     * 
     * @return	numerical id of the current user
     */
    public int getUserName() {
	return 1797;
    }

    /**
     * Type of object that is currently displayed.
     * 
     * @return	Type of object to send to BOB
     */
    public Class getObjectClassToSend() {
	return ObservationBlock.class;
    }

    /**
     * Is there a selected object of the specified type?
     * 
     * @param objType	Type of object to be checked
     * 
     * @return	true if an object of this type has been selected
     */
    public boolean hasValidSelection(Class objType) {
	return true;
    }


 /**
     * Is there a selected object of the specified type?
     * 
     * @param objType	Type of object to be checked
     * 
     * @return	true if an object of this type has been selected
     */
    public boolean hasValidSelection() {
	return true;
    }

    /**
     * The id of the currently selected object of the given type.
     * 
     * @return	id of selected object, or 0 if nothing selected
     */
    public long getSelection(Class objType) {
	return ob_.getId();
    }


    
    public long[] getSelections(String num,Class objType) {
        long[] returnList = new long[1];
	returnList[0]= ob_.getId();
	return  returnList;
    }


    /**
     * A Java Component on which dialog boxes can be based.
     * 
     * @return	An AWT component
     */
    public Component getContainer() {
	return null;
    }

}


