package org.eso.ohs.phase2.apps.p2pp.actions;

import javax.swing.JFrame;

import org.eso.ohs.core.gui.baseaction.IncrementalAction;
import org.eso.ohs.core.gui.baseaction.IncrementalActionAutomaton;
import org.eso.ohs.core.gui.utilities.Utilities;
import org.eso.ohs.phase2.apps.p2pp.MainWindow;

/**
 * Utility base class to perform actions on multiple objects,
 * eg duplication of multiple BusinessObject instances.
 * 
 * <p>
 * $Id: P2PPIncrementalActionAutomaton.java,v 1.6 2005/02/11 10:31:49 tcanavan Exp $
 * <p>
 * @author Bob Kemp
 */
public class P2PPIncrementalActionAutomaton extends IncrementalActionAutomaton {

  
    private Object memento_;


    /**
     * Constructor.
     * 
     * @param action	Object that will perform the steps of a larger action
     * @param frm	Base frame to use for dialog boxes such as dialog_
     * @param msg	Message to display in the progress bar dialog (dialog_)
     */
     public P2PPIncrementalActionAutomaton(IncrementalAction action,
					JFrame frm, String msg) {
        super(action,frm,msg);
    }


    public void closeViews() {
        MainWindow.getView().setDisplaySuppressed(true);
	if (maximum_ > SHORT_ACTION_THRESHOLD) {
			    // Save record of which views were visible.
		memento_ = MainWindow.getView().hideViews();
	}
    }



    public void cleanUpAtEnd() {
	if (memento_ != null) {
	    MainWindow.getView().restoreViews(memento_);
	}
	MainWindow.getView().setDisplaySuppressed(false);
	if (dialog_ != null) {
	    dialog_.dispose();
	}
	Utilities.normalCursor(baseFrame_);
	action_.endOfAction();
    }  
}


