package org.eso.ohs.phase2.visibility;

/**
 * A PCFPlotterFilter extension for plotting moon distance. The class accepts
 * a constraint value, and uses this to return a value of either 1 (the
 * the moon distance is greater than or equal to constraint) or 0 (the moon 
 * distance is less than the constraint).
 *
 * @author Nick Kornweibel for ESO.
 */

public class MoonDistanceFilter extends PCFPlotterFilter {

    private double constraint_;

    public MoonDistanceFilter(double constraint) {
        setConstraint(constraint);
    }

    public double getContraint() {
        return constraint_;
    }

    public void setConstraint(double constraint) {
        constraint_ = constraint;
    }

    public double input(PCFInterval interval)
            throws PCFPlotterFilter.ValueRejectedException {
        double rc;
        if (interval.getValue() >= constraint_) {
            rc = 1.0;
        } else {
            rc = 0.0;

        }
        return rc;
    }
}
