package org.eso.ohs.scripting;

/**
 * This interface defines the Time Intervals for an ObservationBlock.
 *
 * IMPORTANT: Changes to this interface must be reflected in a revised 
 * version string in the ScriptingBox class.
 *
 * @author Nick Kornweibel
 */

public interface TimeIntervalSetAPI {

    /**
     * Get the name of this time interval set
     * @return the name of this time interval set
     */

    public String getName();

    /**
     * Get the id for this time interval set
     * @return string containing the id for this time interval set
     */

    public String getId();

    /**
     * Get the number of time intervals in the set
     * @return the number of time intervals
     */

    public int getNumberOfTimeIntervals();

    /**
     * Get the time interval at the specified index, or null if
     * the index is invalid.
     * @param index of time interval (starting from 0)
     * @return the TimeInterval at the index
     */

    public TimeIntervalAPI getTimeInterval(int index);
}
